module ClickWindow3D_V2_Trial_mm


  module CW_Trial_mm
  
      path_to_components = File.join(File.dirname(__FILE__), 'Components')
	  @@path_to_02 = File.join(path_to_components, 'Sliding Window LT.skp')
      @@path_to_resources = File.join(File.dirname(__FILE__), 'Resources')
	  
	  
	  if ($rps_file)
	  printf("***** Loading: %s\n", File.basename($rps_file))
      else
	  printf("***** Loading: ClickWindow3D_V2_Trial_mm.rb\n")
      end
	
      def self.import00
      path = Sketchup.find_support_file("Control Panel.skp", 
      "Plugins/TNT_ClickWindow3D_V2_Trial_mm/Components/")
      model = Sketchup.active_model  
      definitions = model.definitions 
	  if definition = definitions['Control Panel'] 
      else
      definition = definitions.load(path) 
	  end
	  if definition.instances.length == 1 
	  instance = definition.instances[0] 
	  elsif definition.instances.length > 1
      definition.instances [1..-1].each {| i | i.erase! }
      instance = definition.instances[0]
	  else
	  point = Geom::Point3d.new(0, 0, 0)
      transformation = Geom::Transformation.new(point) 
	  instance = model.entities.add_instance(definition, transformation)
	  layers = model.layers
      new_layer = layers.add "Click-Window 3D"
      new_layer.visible = false
	  instance.layer = new_layer
      end
	  end
	  
	  
	  def self.import02
	  Sketchup.active_model.import(@@path_to_02)
	  import00
	  end
	 
	  
	  def self.options
	  if $dc_observers.get_latest_class.configure_dialog_is_visible
	  $dc_observers.get_latest_class.close_configure_dialog
	  else
	  $dc_observers.get_latest_class.show_configure_dialog
	  end
	  Sketchup.send_action("selectSelectionTool:")
	  end
	  
	  def self.panel
      import00
      panelmove
	  mode2active
	  $dc_observers.get_latest_class.close_configure_dialog 
      Sketchup.active_model.select_tool(DCInteractTool.new($dc_observers))
	  layeradd = Sketchup.active_model  
      layers = layeradd.layers
      new_layer = layers.add "Click-Window 3D" 
      if new_layer.visible?
      new_layer.visible = false
      else
      new_layer.visible = true
      end
      end
	  	  
	  def self.evolving
      UI.openURL("http://www.window3dmodel.com/click-window-3d-pro-and-lt")
	  end	  
	  	  	  	  
	  def self.liensite1
      UI.openURL("http://www.window3dmodel.com/home")
      end

	  def self.liensite2
      UI.openURL("http://www.composant-dynamique.com/home")
      end
	  
      def self.layerhid
      model = Sketchup.active_model
      layers = model.layers
      new_layer = layers.add "Click-Window 3D"
      new_layer.visible = false
      end
	  
	  def self.panelmove
	  model = Sketchup.active_model
	  definition = model.definitions["Control Panel"]
	  instances = definition.instances
      instance = instances[0]
      model = Sketchup.active_model
	  view = model.active_view
	  camera = view.camera
	  eye = camera.eye 
	  target = camera.target 
	  variable = [0,0,0]
	  zvec = target - eye - variable 
	  zvec.normalize! 
	  up = camera.up 
	  printf("eye: %s target: %s up: %s\n", eye, target, variable, up)
	  p001 = Geom::Vector3d.new(0,0,0)
      angle = p001.angle_between(up)
      printf("angle: %s\n", angle)
      printf("eye: %s zvec: %s angle: %s\n", eye, zvec, angle)
      new_transform = Geom::Transformation.rotation(target, zvec, angle)
      xaxis = zvec.cross(up)
      printf("eye: %s xaxis: %s up: %s zvec: %s\n", eye, xaxis, up, zvec)
      new_transform = Geom::Transformation.axes(eye, xaxis, up, zvec)
      instance.transformation = new_transform 
      end
	 
	  
	  def self.mode1
	  layerhid
	  @commandA.set_validation_proc{MF_CHECKED}
	  @commandB.set_validation_proc{MF_UNCHECKED}
	  @commandP.set_validation_proc{MF_GRAYED}
	  @commandO.set_validation_proc{MF_ENABLED}
	  @commandC.set_validation_proc{MF_ENABLED}
	  Sketchup.send_action("selectSelectionTool:")
	  mode1active
      end
	  
	  
	  def self.mode2
	  import00
	  @commandB.set_validation_proc{MF_CHECKED}
	  @commandA.set_validation_proc{MF_UNCHECKED}
	  @commandO.set_validation_proc{MF_GRAYED}
	  @commandP.set_validation_proc{MF_ENABLED}
	  @commandC.set_validation_proc{MF_GRAYED}
	  mode2active
	  end
	  
	  
	  def self.mode1active
	  model = Sketchup.active_model  
      model_definition = model.definitions
      model_def = model_definition['Control Panel']
      valeur = model_def.get_attribute 'dynamic_attributes','a0000mode'
	  if valeur == "1"
	  puts nil
	  else
      model_def.set_attribute 'dynamic_attributes','a0000mode', '1'
      model_def.set_attribute 'dynamic_attributes','_a0000mode_units', 'STRING'  
      $dc_observers.get_latest_class.redraw_with_undo(model_def.instances[0])
	  end 
      end
	  
	  def self.mode2active
	  model = Sketchup.active_model  
      model_definition = model.definitions
      model_def = model_definition['Control Panel']
      valeur = model_def.get_attribute 'dynamic_attributes','a0000mode'
	  if valeur == "2"
	  puts nil
	  else
      model_def.set_attribute 'dynamic_attributes','a0000mode', '2'
      model_def.set_attribute 'dynamic_attributes','_a0000mode_units', 'STRING'  
      $dc_observers.get_latest_class.redraw_with_undo(model_def.instances[0])
	  end 
      end	  
	  
	  def self.resize
	  result = Sketchup.send_action "selectScaleTool:"
	  end
	  
	  def self.click
	  Sketchup.active_model.select_tool(DCInteractTool.new($dc_observers))
	  end
	  
	  def self.message
	  result = UI.messagebox('Available in Pro version or LT only! Would you Download them Now? ', MB_YESNO)
      if result == IDYES
      UI.openURL("http://www.window3dmodel.com/click-window-3d-pro-and-lt")
      end
	  end
	  
	 	  
      if !file_loaded?(__FILE__)

      su_menu = UI.menu("Plugins")
      cc_menu = su_menu.add_submenu(%Q(ClickWindow3D V2 Trial (mm)))
      tb = UI::Toolbar.new(%Q(ClickWindow3D V2 Trial (mm)))
	  
	  @commandC = UI::Command.new("Scaling"){ CW_Trial_mm.resize }
      @commandC.small_icon = File.join(@@path_to_resources,"add_C.png")
      @commandC.large_icon = File.join(@@path_to_resources,"add_C.png")
      @commandC.tooltip = %Q(Scaling)
      @commandC.status_bar_text = %Q(Scaling)
      @commandC.menu_text = %Q(Scaling)
      cc_menu.add_item(@commandC)
      tb.add_item(@commandC)
	  
	    	  
	  @commandO = UI::Command.new("Personal Settings"){CW_Trial_mm.options}
      @commandO.small_icon = File.join(@@path_to_resources,"add_O.png")
      @commandO.large_icon = File.join(@@path_to_resources,"add_O.png")
      @commandO.tooltip = %Q(Personal Settings)
      @commandO.status_bar_text = %Q(Personal Settings)
      @commandO.menu_text = %Q(Personal Settings)  
      cc_menu.add_item(@commandO)
      tb.add_item(@commandO)
	  
	  
	  @commandA = UI::Command.new("Mode 1"){ CW_Trial_mm.mode1 }
      @commandA.small_icon = File.join(@@path_to_resources,"add_A.png")
      @commandA.large_icon = File.join(@@path_to_resources,"add_A.png")
      @commandA.tooltip = %Q(Mode 1)
      @commandA.status_bar_text = %Q(Mode 1)
      @commandA.menu_text = %Q(Mode 1)
	  @commandA.set_validation_proc{MF_CHECKED}
      cc_menu.add_item(@commandA)
      tb.add_item(@commandA)
	  
	  
	  @commandP = UI::Command.new("Overall Settings"){CW_Trial_mm.panel}
      @commandP.small_icon = File.join(@@path_to_resources,"add_P.png")
      @commandP.large_icon = File.join(@@path_to_resources,"add_P.png")
      @commandP.tooltip = %Q(Overall Settings)
      @commandP.status_bar_text = %Q(Overall Settings)
      @commandP.menu_text = %Q(Overall Settings)
	  @commandP.set_validation_proc{MF_GRAYED}
	  cc_menu.add_item(@commandP)
      tb.add_item(@commandP)
	  
	  
	  @commandB = UI::Command.new("Mode 2"){ CW_Trial_mm.mode2 }
      @commandB.small_icon = File.join(@@path_to_resources,"add_B.png")
      @commandB.large_icon = File.join(@@path_to_resources,"add_B.png")
      @commandB.tooltip = %Q(Mode 2)
      @commandB.status_bar_text = %Q(Mode 2)
      @commandB.menu_text = %Q(Mode 2)
      cc_menu.add_item(@commandB)
      tb.add_item(@commandB)
	  
	  
	  @commandD = UI::Command.new("Click!"){ CW_Trial_mm.click }
      @commandD.small_icon = File.join(@@path_to_resources,"add_D.png")
      @commandD.large_icon = File.join(@@path_to_resources,"add_D.png")
      @commandD.tooltip = %Q(Click!)
      @commandD.status_bar_text = %Q(Click!)
      @commandD.menu_text = %Q(Click!)
      cc_menu.add_item(@commandD)
      tb.add_item(@commandD)
	  
		  
      command01 = UI::Command.new("add French Window"){ CW_Trial_mm.message }
      command01.small_icon = File.join(@@path_to_resources,"add_01.png")
      command01.large_icon = File.join(@@path_to_resources,"add_01.png")
      command01.tooltip = %Q(add French Window)
      command01.status_bar_text = %Q(add French Window)
      command01.menu_text = %Q(add French Window)
      cc_menu.add_item(command01)
      tb.add_item(command01)
	  
	  	  
	  command02 = UI::Command.new("add Sliding Window"){ CW_Trial_mm.import02 }
      command02.small_icon = File.join(@@path_to_resources,"add_02.png")
      command02.large_icon = File.join(@@path_to_resources,"add_02.png")
      command02.tooltip = %Q(add Sliding Window)
      command02.status_bar_text = %Q(add Sliding Window)
      command02.menu_text = %Q(add Sliding Window)
      cc_menu.add_item(command02)
      tb.add_item(command02)
	  
	  
	  command03 = UI::Command.new("add Panoramic Window"){ CW_Trial_mm.message }
      command03.small_icon = File.join(@@path_to_resources,"add_03.png")
      command03.large_icon = File.join(@@path_to_resources,"add_03.png")
      command03.tooltip = %Q(add Panoramic Window)
      command03.status_bar_text = %Q(add Panoramic Window)
      command03.menu_text = %Q(add Panoramic Window)
      cc_menu.add_item(command03)
      tb.add_item(command03)
	  
	  
	  command04 = UI::Command.new("add Hung Window"){ CW_Trial_mm.message }
      command04.small_icon = File.join(@@path_to_resources,"add_04.png")
      command04.large_icon = File.join(@@path_to_resources,"add_04.png")
      command04.tooltip = %Q(add Hung Window)
      command04.status_bar_text = %Q(add Hung Window)
      command04.menu_text = %Q(add Hung Window)
      cc_menu.add_item(command04)
      tb.add_item(command04)
	  
	  	  
	  command05 = UI::Command.new("add Crank Window"){ CW_Trial_mm.message }
      command05.small_icon = File.join(@@path_to_resources,"add_05.png")
      command05.large_icon = File.join(@@path_to_resources,"add_05.png")
      command05.tooltip = %Q(add Crank Window)
      command05.status_bar_text = %Q(add Crank Window)
      command05.menu_text = %Q(add Crank Window)
      cc_menu.add_item(command05)
      tb.add_item(command05)
	  
	  
	  commandEV = UI::Command.new("Evolving to Full Version"){ CW_Trial_mm.evolving }
      commandEV.small_icon = File.join(@@path_to_resources,"add_EV.png")
      commandEV.large_icon = File.join(@@path_to_resources,"add_EV.png")
      commandEV.tooltip = %Q(Evolving to Full Version)
      commandEV.status_bar_text = %Q(Evolving to Full Version)
      commandEV.menu_text = %Q(Evolving to Full Version)
      cc_menu.add_item(commandEV)
      tb.add_item(commandEV)
	  	  
	  
	  commandS1 = UI::Command.new("Help"){ CW_Trial_mm.liensite1 }
      commandS1.small_icon = File.join(@@path_to_resources,"add_S1.png")
      commandS1.large_icon = File.join(@@path_to_resources,"add_S1.png")
      commandS1.tooltip = %Q(Help)
      commandS1.status_bar_text = %Q(Help)	  
	  commandS1.menu_text = %Q(Help)	  
	  cc_menu.add_item(commandS1)        
      tb.add_item(commandS1)
	  
	  	  
	  commandS2 = UI::Command.new("+Plugins"){ CW_Trial_mm.liensite2 }       
      commandS2.small_icon = File.join(@@path_to_resources,"add_S2.png")
      commandS2.large_icon = File.join(@@path_to_resources,"add_S2.png")
      commandS2.tooltip = %Q(+Plugins)
      commandS2.status_bar_text = %Q(+Plugins)  
	  commandS2.menu_text = %Q(Help)  
	  cc_menu.add_item(commandS2)       
      tb.add_item(commandS2)
	  
      tb.restore
 
      file_loaded(__FILE__) 

     end

   end
   
end